package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import java.io.*;
import java.util.*;
import com.bsc.api.element.*;
import java.util.PropertyResourceBundle;
import com.bsc.bean.*;
import com.bsc.api.loader.*;
import java.util.*;
import com.bsc.api.*;
import com.bsc.api.task.*;
import com.bsc.api.group.*;
import com.bsc.api.element.*;
import com.bsc.api.role.*;

public final class RolePolicy_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {


private String showGroupHierarchy(com.bsc.bean.CampusMECBean campusBean, ArrayList groups, ArrayList groupIDs, String roleName, String groupType, ArrayList policyList, ArrayList taskList) {
    Hashtable groupHash = new Hashtable();

    ArrayList childGroups = new ArrayList();
    for( int i = 0; i < groups.size(); ++i)
    {
        ManagedGroup group = (ManagedGroup)groups.get(i);
        if (group.destroyGroup()) {
            childGroups.addAll(group.getManagedGroups());
        }
        groupHash.put(new Long(group.getID()),group);
    }
    
    ArrayList topLevelGroups = new ArrayList();
    for( int i = 0; i < groups.size(); ++i)
    {
        ManagedGroup group = (ManagedGroup)groups.get(i);
        if (!childGroups.contains(new Long(group.getID()))) {
            topLevelGroups.add(group);
        }
    }
    
    return showGroupHierarchy(campusBean, topLevelGroups, groupIDs, roleName, groupType, policyList, taskList, groupHash, "", 1);
}

private String showGroupHierarchy(com.bsc.bean.CampusMECBean campusBean, ArrayList groups, ArrayList groupIDs, String roleName, String groupType, ArrayList policyList, ArrayList taskList, Hashtable groupHash, String parent, int depth)
{
    StringBuffer sb = new StringBuffer();

    int rowCount = 0;
    for( int i = 0; i < groups.size(); ++i)
    {
        ManagedGroup group = (ManagedGroup)groups.get(i);
        if( group.destroyGroup() )
        {
            String groupCount = String.valueOf(
                        campusBean.countMembersOfGroup(group.getName()));

            Long groupID = new Long(group.getID());
            String groupName = group.getNameLabel();
            String gName = group.getName();

            String nodeID = null;
            if (parent.equals("")) {
                nodeID = groupID.toString();
            } else {
                nodeID = parent + '-' + groupID;
            }
            
            String policy = "";
            String securityPolicy = "";
            NameValue cliAcl = null;
            if( groupType.equals("device") )
            {
                policy = campusBean.getPolicyForDeviceGroup( roleName, 
                                                            group.getID());
                securityPolicy = campusBean.getEndPointPolicyForDeviceGroup( 
                                                roleName, group.getID());
                cliAcl = campusBean.getCliForDeviceGroup(roleName, 
                                                         group.getID());
            }
            else
            {
                policy = campusBean.getPolicyForPortGroup( roleName,
                                                            group.getID());
                securityPolicy = campusBean.getEndPointPolicyForPortGroup( 
                                                roleName, group.getID());
                cliAcl = campusBean.getCliForPortGroup(roleName, group.getID());
            }

            if(policy == null )
            {
                policy = "";
            }
            
            if(securityPolicy == null )
            {
                securityPolicy = "";
            }

            boolean isFolder = isFolder(group,groupHash);
            
            sb.append("<tr id=\"");
            sb.append(nodeID);
            sb.append("\" class=\"a\" onMouseOver=\"this.style.backgroundColor='#efefef'\" style=\"BACKGROUND-COLOR:#ffffff\" onMouseOut=\"this.style.backgroundColor='#FFFFFF'\">\n");

            sb.append("  <td id=\"");
            sb.append("td_");
            sb.append(nodeID);
            sb.append("\">\n");
            sb.append("    <div id=\"");
            sb.append("folder_");
            sb.append(nodeID);
            sb.append("\" class=\"tier");
            sb.append(depth);
            sb.append("\">\n");
            sb.append("      <a id=\"");
            sb.append("link_");
            sb.append(nodeID);
            sb.append("\" ");
            if (isFolder) {
                sb.append("onfocus=\"this.blur()\" href=\"#\" onclick=\"toggleRows(this)\" "); 
                sb.append("class=\"folder");
            } else {
                sb.append("class=\"doc");
            }
            sb.append("\">");
            sb.append("</a>\n");
            
            sb.append("      <a href=\"GroupMember.jsp?groupName=");
            sb.append(gName);
            sb.append("\" target=\"_blank\">");
            sb.append(groupName);
            sb.append("</a>\n");
            
            sb.append("    </div>\n");
            sb.append("  </td>\n");
            
            sb.append("  <td>");
            sb.append(groupCount);
            sb.append("</td>\n");
            
            sb.append("  <td>");
            sb.append("<input type=\"text\" class=\"box\" "); 
            sb.append("name=\"policy&amp;");
            sb.append(groupType);
            sb.append("&amp;");
            sb.append(group.getID());
            sb.append("\" value=\"");
            sb.append(policy);
            sb.append("\">\n");
            sb.append("</td>\n");

            sb.append("  <td>");
            sb.append("<select ");
            sb.append("name=\"cliAcl&amp;");
            sb.append(groupType);
            sb.append("&amp;");
            sb.append(group.getID() + "\">\n");
            sb.append("<option value=\"SELECT\"> None </option>\n");
            long taskID = -1;
            try
            {
                taskID = ((Long)cliAcl.getValue()).longValue();
            }
            catch(Exception e) {}
            for( int j = 0; j < taskList.size(); ++j)
            {
                Task cli = (Task)taskList.get(j);
                if( cli.getID() == taskID )
                {
                    sb.append("<option value=\"" + cli.getID() + "\" selected> " + cli.getNameTag() + " </option>\n");
                }
                else
                {
                    sb.append("<option value=\"" + cli.getID() + "\"> " + cli.getNameTag() + " </option>\n");
                }
            }
            sb.append("</select>\n");
            sb.append("</td>\n");

            sb.append("  <td>");
            sb.append("<select ");
            sb.append("name=\"securityPolicy&amp;");
            sb.append(groupType);
            sb.append("&amp;");
            sb.append(group.getID() + "\">\n");
            sb.append("<option value=\"SELECT\"> None </option>\n");
            for( int j = 0; j < policyList.size(); ++j)
            {
                String pol = (String)policyList.get(j);
                if( securityPolicy.equals(pol) )
                {
                    sb.append("<option value=\"" + pol + "\" selected> " + pol + " </option>\n");
                }
                else
                {
                    sb.append("<option value=\"" + pol + "\"> " + pol + " </option>\n");
                }
            }
            sb.append("</select>\n");
            sb.append("</td>\n");

            sb.append("</tr>\n");
            
            try {
                ArrayList list = new ArrayList();
                ArrayList mgList = group.getManagedGroups();
                for( int j = 0; j < mgList.size(); ++j)
                {
                    Long id = (Long)mgList.get(j);
                    list.add(groupHash.get(id));
                }

                sb.append(showGroupHierarchy(campusBean, list, groupIDs, roleName, groupType, policyList, taskList, groupHash, nodeID, depth+1));
            } catch (Exception e) {
                sb.append(e);
            }

            rowCount++;
        }
    }

    return sb.toString();
}

private boolean isFolder(ManagedGroup group, Hashtable groupHash)
{
    if (group.getManagedGroups().size() > 0)
    {
        ArrayList mgList = group.getManagedGroups();
        for (int j = 0; j < mgList.size(); ++j)
        {
            Long id = (Long) mgList.get(j);
            ManagedGroup mg = (ManagedGroup) groupHash.get(id);
            if (mg.destroyGroup())
            {
                return true;
            }
        }
    }
    return false;
}

  private static java.util.Vector _jspx_dependants;

  static {
    _jspx_dependants = new java.util.Vector(5);
    _jspx_dependants.add("/common/common.jsp");
    _jspx_dependants.add("/common/primaryHeader.jsp");
    _jspx_dependants.add("/common/secondaryHeader.jsp");
    _jspx_dependants.add("/common/goMenu.jsp");
    _jspx_dependants.add("/RolePolicyTable.jsp");
  }

  public java.util.List getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write('\n');
      out.write('\n');
      out.write('\n');
      com.bsc.bean.UserBean ub = null;
      synchronized (session) {
        ub = (com.bsc.bean.UserBean) _jspx_page_context.getAttribute("ub", PageContext.SESSION_SCOPE);
        if (ub == null){
          ub = new com.bsc.bean.UserBean();
          _jspx_page_context.setAttribute("ub", ub, PageContext.SESSION_SCOPE);
          out.write('\n');
        }
      }
      out.write('\n');
      out.write('\n');
      com.bsc.bean.DeviceBean devBean = null;
      synchronized (session) {
        devBean = (com.bsc.bean.DeviceBean) _jspx_page_context.getAttribute("devBean", PageContext.SESSION_SCOPE);
        if (devBean == null){
          devBean = new com.bsc.bean.DeviceBean();
          _jspx_page_context.setAttribute("devBean", devBean, PageContext.SESSION_SCOPE);
          out.write('\n');
          out.write(' ');
          out.write(' ');
          org.apache.jasper.runtime.JspRuntimeLibrary.handleSetProperty(_jspx_page_context.findAttribute("devBean"), "userKey",
ub.getUserKey());
          out.write('\n');
        }
      }
      out.write('\n');
      out.write('\n');

    if( !ub.isValidUser() )
    {
        String appleKey = request.getParameter("appleKey");

        if( appleKey == null )
        {
            if(session != null) 
            {
                try
                {
                    session.invalidate();
                }
                catch(Exception e)
                {
                    System.out.println("Error trying to invalidate session in common.jsp");
                    e.printStackTrace();
                }
            }

      out.write("\n");
      out.write("            ");
      if (true) {
        _jspx_page_context.forward("Relogin.jsp");
        return;
      }
      out.write(' ');
      out.write('\n');

        }
        else
        {
            if(!ub.validateUserKey( appleKey ) )
            {
                if(session != null)
                {
                    try
                    {
                        session.invalidate();
                    }
                    catch(Exception e)
                    {
                        System.out.println("Error trying to invalidate session in common.jsp");
                        e.printStackTrace();
                    }
                }

      out.write("\n");
      out.write("                ");
      if (true) {
        _jspx_page_context.forward("Relogin.jsp");
        return;
      }
      out.write(' ');
      out.write('\n');

            } 
        }
    }

    // The following variables are used by the included jsp files.
    String primaryHeaderTitle = " ";
    String leftSideSecondaryText = ub.getTag( "yams.jsp.Tname");
    String leftSideSecondaryValue = " ";
    String rightSideSecondaryText = null;
    String rightSideSecondaryValue = null;
    String rightSidePage = null;
    String helpPage = null;
    boolean printPage = false;
    String jsource  = "empty.js";
    boolean enable_plugin = false;
    boolean showGoMenu = true;
    boolean showMenu = true;
    
    // The order of YUI imports are important.  If you are using other YUI components on your page,
    // you may need to control the order of imports, and therefore would want to set this to false
    // so that goMenu.jsp won't load the YUI scripts.  In that case you would be responsible for
    // including those YUI scripts yourself.
    boolean includeGoMenuYuiImports = true;

    boolean rwAccess = false;

    devBean.setUserKey( ub.getUserKey() );

    String deviceID = request.getParameter("deviceID");

    ManagedElement theDev = null;
    byte devStatus = ManagedElementDefs.CONTACT_UNKNOWN;
    if( deviceID != null )
    {
        theDev = devBean.findByElementID( deviceID );
        if( theDev != null )
        {
            devStatus = theDev.getStatus();
            rwAccess = ub.hasReadWriteAccess( theDev );
            leftSideSecondaryValue = theDev.getName();
            if(leftSideSecondaryValue.equals("Campus Manager"))
                {
                    leftSideSecondaryValue = ub.getTag( "com.bsc.brand.ProductName");
                }
            rightSideSecondaryText = ub.getTag( "yams.jsp.Tstatus" );
            rightSideSecondaryValue = theDev.getImageLarge(ub.getLocale());
            rightSidePage = "DeviceProperty.jsp";
        }
    }

    String style=(String)session.getAttribute("style");

    String cm_bgcolor="#FCFFF0";    
    //F0EEE4


    String spaceColor = "#66CC33";
    int spaceSize = 0;
    ArrayList tabList = new ArrayList();
    JspTabNode node = null;

    // Values used to resize the window
    boolean resize = false;

    int resizeWidth = 0;
    int resizeHeight = 0;
    String bodyClass = null;

      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write('\n');
      out.write('\n');

    // Redefine the variables for this view.


    resize = true;
    resizeWidth = 750;
    resizeHeight = 700;

    rightSidePage = null;

    int selectedMenu = 0;
				
    int selPage = request.getRequestURL().toString().indexOf( "DeviceProperty.jsp" ); 
				
    if( selPage != -1 )
    {
        selectedMenu = 0;
    }
    primaryHeaderTitle = ub.getTag( "yams.jsp.Role.Mappings" ); 
    helpPage = "docs/index.htm?context=User_Guide&topic=CM_Role_Mgmt_Mappings&single=true";

      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');

    String product = "";
    String version = "";
    String appliance = "";

    SoftwareProperties swprop = ub.getSoftwareProperties();
   
    String stat = "Running";

    if( swprop != null )
    {
        appliance = swprop.getApplianceName();
        product = swprop.getProductVersionShort();
        version = swprop.getCMOSShort();
        if( "NetworkControlManager".equals( product ))
        {
            product = "Network Control Manager";
        }

    }
    else
    {
        stat = "Down";
    }

    String servername =  ub.getNamingFactory();

      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n");
      out.write("\"http://www.w3.org/TR/html4/loose.dtd\">\n");
      out.write("<html>\n");
      out.write("<head>\n");
      out.write("  <title>");
      out.print( servername );
      out.write(" :: ");
      out.print( version );
      out.write(" :: ");
      out.print( product );
      out.write(" </title>\n");
      out.write("  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
      out.write("  <link rel=\"stylesheet\" href=\"header.css\" type=\"text/css\">\n");
      out.write("  <link rel=\"stylesheet\" href=\"body.css\" type=\"text/css\">                                                    \n");
      out.write("  <script language=Javascript src=\"./js/");
      out.print(jsource);
      out.write("\"></script>\n");
      out.write("\n");
      out.write(" \n");
      out.write("\n");

    if(resize)
    {

      out.write("\n");
      out.write("        <SCRIPT LANGUAGE = \"Javascript\">\n");
      out.write("\n");
      out.write("        w = \"");
      out.print(resizeWidth);
      out.write("\";\n");
      out.write("        h = \"");
      out.print(resizeHeight);
      out.write("\";\n");
      out.write("        window.resizeTo(w,h)\n");
      out.write("        \n");
      out.write("        </script>\n");
      out.write(" \n");

    }

      out.write("\n");
      out.write("\t\t \n");
      out.write("</head>\n");
 if (bodyClass != null) { 
      out.write("\n");
      out.write("<body class=\"");
      out.print(bodyClass );
      out.write('"');
      out.write('>');
      out.write('\n');
 } else { 
      out.write("\n");
      out.write("<body>\n");
 } 
      out.write("\n");
      out.write("<div id=\"header\">\n");
      out.write("  <div id=\"productLogo\" >\n");
      out.write("  <a href=\"");
      out.print( ub.getTag( "com.bsc.brand.CompanyInfo" ) );
      out.write("\" target=\"_blank\">\n");
      out.write("    <img src=\"");
      out.print( ub.getTag( "com.bsc.brand.IMG_JPG" ) );
      out.write("\" /></a> \n");
      out.write("  </div>\n");
      out.write('\n');
      out.write("  <div id=\"icon\">\n");
      out.write("    ");
 if( rightSideSecondaryText == null && rightSidePage == null ) { 
      out.write("\n");
      out.write("    ");
 } else if( rightSideSecondaryText == ub.getTag( "yams.jsp.Logout" ) ) { 
      out.write(" \n");
      out.write("      &nbsp;\n");
      out.write("    ");
 } else if( rightSidePage == null  && rightSideSecondaryText != null) { 
      out.write("\n");
      out.write("      <div id=\"iconbg\"><img src=\"applets/");
      out.print(rightSideSecondaryValue);
      out.write("\" height=\"32\" width=\"32\" border=\"0\"></div>\n");
      out.write("    ");
 } else if( rightSideSecondaryText != null && rightSidePage != null ) { 
      out.write("\n");
      out.write("      <div id=\"iconbg\"><a href=\"");
      out.print(rightSidePage);
      out.write("?deviceID=");
      out.print(deviceID);
      out.write("\" target=\"_blank\">\n");
      out.write("      <img src=\"applets/");
      out.print(rightSideSecondaryValue);
      out.write("\" height=\"32\" width=\"32\" border=\"0\"></a></div>\n");
      out.write("    ");
 } else { 
      out.write("\n");
      out.write("      &nbsp;\n");
      out.write("    ");
 } 
      out.write("\n");
      out.write("  </div>\n");
      out.write("\n");
      out.write("\n");
      out.write("  <div id=\"stitle\" >");
      out.print(primaryHeaderTitle);
      out.write("<br>");
      out.print(leftSideSecondaryValue);
      out.write("</div>\n");
      out.write("</div>\n");
      out.write("\n");
      out.write("  <div id=\"help\" >\n");
      out.write("    ");
 if( showMenu ) { 
      out.write("\n");
      out.write("      ");
 if( showGoMenu && ub.isUserAdministrator() && !ub.isOnNCM() ) { 
      out.write("\n");
      out.write("        ");
 if(includeGoMenuYuiImports){ 
      out.write("\n");
      out.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"js/yui/menu/assets/skins/sam/menu.css\">\n");
      out.write("<script type=\"text/javascript\" src=\"js/yui/yahoo-dom-event/yahoo-dom-event.js\"></script>\n");
      out.write("<script type=\"text/javascript\" src=\"js/yui/container/container_core.js\"></script>\n");
      out.write("<script type=\"text/javascript\" src=\"js/yui/menu/menu.js\"></script>\n");
 } 
      out.write("\n");
      out.write("\n");
      out.write("<script type=\"text/javascript\">\n");
      out.write("YAHOO.util.Event.onContentReady(\"topMenu\",function() {\n");
      out.write("  var oMenuBar = new YAHOO.widget.MenuBar(\"topMenu\",{autosubmenudisplay:false, hidedelay: 750, lazyload: true,maxHeight: 900});\n");
      out.write("  oMenuBar.render();\n");
      out.write("});\n");
      out.write("</script>\n");
      out.write("<style type=\"text/css\">\n");
      out.write("#topMenu { z-index: 20000 }\n");
      out.write("#goMenu { z-index: 20000 }\n");
      out.write("#help .yui-skin-sam a:visited { color: black; background-color: inherit; }\n");
      out.write("#help .yui-skin-sam a.yuimenuitem { color: inherit; background: inherit;}\n");
      out.write("#help .yui-skin-sam a { color: black; background-color: inherit; }\n");
      out.write("#help .yui-skin-sam a:hover { color: #ff6600; background-color: inherit; }\n");
      out.write("</style>\n");

    ArrayList gm_labels = ub.getTagStartsWith("com.bsc.ui.common.navigation.view.APPLETS.label.");
    Hashtable gm_targets = new Hashtable();
    Hashtable gm_elements = new Hashtable();

      out.write("\n");
      out.write("<div class=\"yui-skin-sam\">\n");
      out.write("<div class=\"yui-t1\">\n");
      out.write("<div id=\"topMenu\" class=\"yuimenubar yuimenubarnav\">\n");
      out.write("<div class=\"bd\">\n");
      out.write("<ul class=\"first-of-type\">\n");
      out.write("<li class=\"yuimenubaritem first-of-type\">\n");
      out.write("<a class=\"yuimenubaritemlabel\" href=\"#\">Go</a>\n");
      out.write("<div id=\"goMenu\" class=\"yuimenu\">\n");
      out.write("<div class=\"bd\">\n");
      out.write("<ul>\n");

    for( int zzz=0; zzz < gm_labels.size(); zzz++ )
    {
        String gm_tag = "com.bsc.ui.common.navigation.view.APPLETS.label."+
                     (String)gm_labels.get(zzz);
        String gm_targetTag = "com.bsc.ui.common.navigation.view.APPLETS.target."+
                     (String)gm_labels.get(zzz);
        String gm_typeTag = "com.bsc.ui.common.navigation.view.APPLETS.type."+
                     (String)gm_labels.get(zzz);
        String gm_url = ub.getTag(gm_targetTag);
        String gm_type = ub.getTag(gm_typeTag);
        if ( gm_type != null && !gm_type.equals(gm_typeTag))
        {
            String deviceId = (String)gm_elements.get(gm_type);
            if ( deviceId == null )
            {
                try {
                    byte elementId = Byte.parseByte(gm_type);
                    ArrayList go_meList = devBean.getElementsByType(elementId);
                    if (go_meList.size() > 0)
                    {
                        ManagedElement m = (ManagedElement)go_meList.get(0);
                        deviceId = Long.toString(m.getID());
                        gm_elements.put(gm_type, deviceId);
                    }
                }
                catch (Exception e) {
                    e.printStackTrace();
                }
            }
            gm_url += "?deviceID="+deviceId;
        }
        gm_labels.set(zzz,ub.getTag(gm_tag));
        gm_targets.put(gm_labels.get(zzz),gm_url);
    }
    Collections.sort(gm_labels);
    boolean isSubmenu = false;
    for( int zzz=0; zzz < gm_labels.size(); zzz++ )
    {
        String label = (String)gm_labels.get(zzz);
        String url = (String)gm_targets.get(label);
        int subIndex = label.indexOf("->");
        if (subIndex != -1) {
            String menulabel = label.substring(0,subIndex);
            label = label.substring(subIndex+2);
            if (!isSubmenu) {
                // start manage

      out.write("\n");
      out.write("<li class=\"yuimenuitem\"><a class=\"yuimenuitemlabel\" href=\"#\">");
      out.print(menulabel );
      out.write("</a>\n");
      out.write("<div id=\"");
      out.print(menulabel );
      out.write("\" class=\"yuimenu\">\n");
      out.write("<div class=\"bd\">\n");
      out.write("<ul class=\"first-of-type\">\n");

            }
            isSubmenu = true;
        } else {
            if (isSubmenu) {
                isSubmenu = false;
                // end manage

      out.write("\n");
      out.write("</ul>\n");
      out.write("</div>\n");
      out.write("</div>\n");
      out.write("</li>\n");

            }
        }

      out.write("\n");
      out.write("<li class=\"yuimenuitem\"><a class=\"yuimenuitemlabel\" href=\"");
      out.print(url);
      out.write('"');
      out.write('>');
      out.write('\n');
      out.print(label);
      out.write("</a></li>\n");

    }

      out.write("\n");
      out.write("</ul>\n");
      out.write("</div>\n");
      out.write("</div>\n");
      out.write("</li>\n");

    if( helpPage != null && helpPage.length() > 0 ) {

      out.write("\n");
      out.write("<li class=\"yuimenubaritem\">\n");
      out.write("<a class=\"yuimenubaritemlabel\" href=\"#\" onclick=\"javascript:window.open('");
      out.print(helpPage);
      out.write("')\">Help</a>\n");
      out.write("</li>\n");

    } else {

      out.write("\n");
      out.write("<li class=\"yuimenubaritem\">\n");
      out.write("<a href=\"#\" class=\"yuimenubaritemlabel\">Help</a>\n");
      out.write("</li>\n");

    }

      out.write("\n");
      out.write("<li class=\"yuimenubaritem\">\n");
      out.write("<a class=\"yuimenubaritemlabel\" href=\"Logout.jsp\">Logout</a>\n");
      out.write("</li>\n");
      out.write("</ul>\n");
      out.write("</div>\n");
      out.write("</div>\n");
      out.write("</div>\n");
      out.write("</div>");
      out.write("\n");
      out.write("      ");
 } else { 
      out.write("\n");
      out.write("        ");
 if (ub.isOnNCM()) { 
      out.write("\n");
      out.write("        <a href=\"NCMMgtGlobalFind.jsp\" > Main |</a>\n");
      out.write("        ");
 } 
      out.write("\n");
      out.write("        ");
 if( helpPage  == "MainViewHelp.jsp") { 
      out.write("\n");
      out.write("          <a href='javascript://'  onClick=\"javascript:window.open('");
      out.print(helpPage);
      out.write("',          \n");
      out.write("             'BradfordCampusManager','width=680,height=500,statusbar=no,scrollbars=yes,toolbar=no,resizable=yes')\"> Help |</a>\n");
      out.write("        ");
 } else if ( helpPage  == "OperatorHelp.jsp") { 
      out.write("\n");
      out.write("          <a href='javascript://'  onClick=\"javascript:window.open('");
      out.print(helpPage);
      out.write("', \n");
      out.write("             'BradfordCampusManager','width=680,height=300,statusbar=no,scrollbars=yes,toolbar=no,resizable=yes')\"> Help |</a>\n");
      out.write("        ");
 } else if ( helpPage  == "HelpDeskHelp.jsp") { 
      out.write("\n");
      out.write("          <a href='javascript://'  onClick=\"javascript:window.open('");
      out.print(helpPage);
      out.write("', \n");
      out.write("             'BradfordCampusManager','width=680,height=380,statusbar=no,scrollbars=yes,toolbar=no,resizable=yes')\"> Help |</a>\n");
      out.write("        ");
 } else if ( helpPage  != null ) { 
      out.write("\n");
      out.write("          <a href='javascript://'  onClick=\"javascript:window.open('");
      out.print(helpPage);
      out.write("',  \n");
      out.write("             'BradfordCampusManager','width=680,height=380,statusbar=no,scrollbars=yes,toolbar=no,resizable=yes')\"> Help |</a>\n");
      out.write("        ");
 } 
      out.write("\n");
      out.write("        <a href=\"Logout.jsp\" > Logout </a>\n");
      out.write("      ");
 } 
      out.write("\n");
      out.write("    ");
 } 
      out.write("\n");
      out.write("  </div> \n");
      out.write("\n");
      out.write('\n');
      out.write(' ');
      out.write('\n');
      com.bsc.bean.CampusMECBean campusBean = null;
      synchronized (_jspx_page_context) {
        campusBean = (com.bsc.bean.CampusMECBean) _jspx_page_context.getAttribute("campusBean", PageContext.PAGE_SCOPE);
        if (campusBean == null){
          campusBean = new com.bsc.bean.CampusMECBean();
          _jspx_page_context.setAttribute("campusBean", campusBean, PageContext.PAGE_SCOPE);
          out.write('\n');
          org.apache.jasper.runtime.JspRuntimeLibrary.handleSetProperty(_jspx_page_context.findAttribute("campusBean"), "userKey",
ub.getUserKey());
          out.write('\n');
        }
      }
      out.write('\n');
      com.bsc.bean.GroupBean groupBean = null;
      synchronized (session) {
        groupBean = (com.bsc.bean.GroupBean) _jspx_page_context.getAttribute("groupBean", PageContext.SESSION_SCOPE);
        if (groupBean == null){
          groupBean = new com.bsc.bean.GroupBean();
          _jspx_page_context.setAttribute("groupBean", groupBean, PageContext.SESSION_SCOPE);
          out.write('\n');
          org.apache.jasper.runtime.JspRuntimeLibrary.handleSetProperty(_jspx_page_context.findAttribute("groupBean"), "userKey",
ub.getUserKey());
          out.write('\n');
        }
      }
      out.write('\n');
      com.bsc.bean.AgentPolicyBean agentPolicyBean = null;
      synchronized (session) {
        agentPolicyBean = (com.bsc.bean.AgentPolicyBean) _jspx_page_context.getAttribute("agentPolicyBean", PageContext.SESSION_SCOPE);
        if (agentPolicyBean == null){
          agentPolicyBean = new com.bsc.bean.AgentPolicyBean();
          _jspx_page_context.setAttribute("agentPolicyBean", agentPolicyBean, PageContext.SESSION_SCOPE);
          out.write('\n');
          org.apache.jasper.runtime.JspRuntimeLibrary.handleSetProperty(_jspx_page_context.findAttribute("agentPolicyBean"), "userKey",
ub.getUserKey());
          out.write('\n');
        }
      }
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');

    ArrayList policyList = agentPolicyBean.getAgentPolicies();
    ArrayList taskList = campusBean.getCliTasks();

    String groupType = request.getParameter("groupType");
    if( groupType == null )
    {
        groupType = "device";
    }
    ArrayList deviceGroups = null;
    if( groupType.equals("device") )
    {
        deviceGroups = groupBean.getGroupsByClass( ub.getUserKey(),
                                    ManagedElementDefs.DEVICE);
    }
    else
    {
        deviceGroups = groupBean.getGroupsByClass( ub.getUserKey(),
                                    ManagedElementDefs.COMPONENT);
    }

    if( deviceGroups == null )
    {
        deviceGroups = new ArrayList();
    }

    String roleName = request.getParameter("roleName");
    if( roleName == null )
    {
        roleName = "";
    }

    String roleID = request.getParameter("roleID");

    String clientCount = String.valueOf(campusBean.countClientByRole(roleName));

    ArrayList groupIDs = new ArrayList();

    String action = request.getParameter("action");
    if( action != null && action.equals("Apply") )
    {
        ArrayList mappings = campusBean.getRoleMappings(roleName);

        Hashtable newMaps = new Hashtable();
        Hashtable newSecurity = new Hashtable();
        Hashtable newCli = new Hashtable();

        Enumeration attrs = request.getParameterNames();

        while( attrs.hasMoreElements() )
        {
            String attr = (String)attrs.nextElement();
            String value = request.getParameter( attr );
            value = value.trim();

            if( attr.startsWith("policy&"+groupType+"&") )
            {
                String idStr = attr.substring(7+groupType.length()+1);
                try
                {
                    long gID =  Long.parseLong(idStr);
                    if( idStr.length() > 0 && value.length() > 0 )
                    {
                        ArrayList list = (ArrayList)newMaps.get(value);
                        if( list == null )
                        {
                            list = new ArrayList();
                            newMaps.put(value, list);
                        }
                        LocationPolicy pol = new LocationPolicy(gID);
                        list.add(pol);
                    }
                }
                catch(Exception e){}
            }
            else if( attr.startsWith("securityPolicy&"+groupType+"&") )
            {
                try
                {
                    String idStr = attr.substring(15+groupType.length()+1);
                    Long gID =  new Long(Long.parseLong(idStr));
                    if( !value.equals("SELECT") )
                    {
                        newSecurity.put(gID, value);
                    }
                }
                catch(Exception e){}
            }
            else if( attr.startsWith("cliAcl&"+groupType+"&") )
            {
                try
                {
                    String idStr = attr.substring(7+groupType.length()+1);
                    Long gID =  new Long(Long.parseLong(idStr));
                    if( !value.equals("SELECT") )
                    {
                        newCli.put(gID, value);
                    }
                }
                catch(Exception e){}
            }
        }
        if( newMaps.size() > 0 )
        {
            Enumeration keys = newMaps.keys();
            for(Enumeration e = newMaps.elements(); e.hasMoreElements() ;)
            {
                ArrayList list = (ArrayList)e.nextElement();
                String policy = (String)keys.nextElement();
                for(int i=0; i< list.size(); i++)
                {
                    LocationPolicy val = (LocationPolicy)list.get(i);
                    String pol = (String)newSecurity.get(
                                       new Long(val.getGroupID()) );
                    val.setEndPointPolicy(pol);
                    String task = (String)newCli.get(
                                       new Long(val.getGroupID()) );
                    long taskID = -1;
                    try
                    {
                        taskID = Long.parseLong(task);
                    }
                    catch(Exception ex){}
System.out.println("val.setCliAcl = " + taskID);
                    val.setCliAcl(taskID);
                }
            }
        }
        for(int i=0; i<mappings.size(); i++)
        {
            RoleMapping map = (RoleMapping)mappings.get(i);
            ArrayList otherType = null;
            if( groupType.equals("port") )
            {
                otherType = map.getDeviceGroups();
            }
            else
            {
                otherType = map.getPortGroups();
            }
            String policy = map.getPolicy();
            ArrayList list = (ArrayList)newMaps.get(policy);
            if( list == null && otherType.size() == 0 )
            {
                campusBean.removeRoleMapping(roleName, policy);
            }
        }
        for(int i=0; i<mappings.size(); i++)
        {
            RoleMapping map = (RoleMapping)mappings.get(i);
            String policy = map.getPolicy();
            ArrayList portList = null;
            ArrayList deviceList = null;
            if( groupType.equals("port") )
            {
                portList = (ArrayList)newMaps.remove(policy);
                if( portList == null )
                {
                    portList = new ArrayList();
                }
                deviceList = map.getDeviceGroups(); 
            }
            else
            {
                deviceList = (ArrayList)newMaps.remove(policy);
                if( deviceList == null )
                {
                    deviceList = new ArrayList();
                }
                portList = map.getPortGroups(); 
            }
            
            if( deviceList != null && portList != null)
            {
                campusBean.addRoleMapping(roleName, policy, deviceList,
                                           portList);
            }
        }
        if( newMaps.size() > 0 )
        {
            Enumeration keys = newMaps.keys();
            ArrayList portList = null;
            ArrayList deviceList = null;
            for(Enumeration e = newMaps.elements(); e.hasMoreElements() ;)
            {
                if( groupType.equals("port") )
                {
                    portList = (ArrayList)e.nextElement();
                    deviceList = new ArrayList(); 
                }
                else
                {
                    deviceList = (ArrayList)e.nextElement();
                    portList = new ArrayList();
                }
                String policy = (String)keys.nextElement();
                if( deviceList != null && portList != null)
                {
                    campusBean.addRoleMapping(roleName, policy, deviceList,
                                               portList);
                }
            }
        }
    }

      out.write("\n");
      out.write("\n");
      out.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"js/sstree/sstree.css\">\n");
      out.write("\n");
      out.write("<!-- Not sure why, but these styles for the images don't -->\n");
      out.write("<!-- work if they are in the sstree stylesheet -->\n");
      out.write("<style type=\"text/css\">\n");
      out.write(".folder { background: url(js/sstree/folder-open.gif)  no-repeat; float: left; height: 14px; width: 12px; padding-right: 3px }\n");
      out.write(".doc { background: url(js/sstree/file.gif) no-repeat; float: left; height: 14px; width: 12px; padding-right: 3px }\n");
      out.write("</style>\n");
      out.write(" \n");
      out.write("<script src=\"js/sstree/sstree.js\"></script>\n");
      out.write("\n");
      out.write("<script type=\"text/javascript\">\n");
      out.write("<!--\n");
      out.write("function validate(f) {\n");
      out.write("  try {\n");
      out.write("    var elements = f.elements;\n");
      out.write("    var i = 0;\n");
      out.write("    for (i = 0; i < elements.length; i++) {\n");
      out.write("      var el = elements[i];\n");
      out.write("      var pre = el.name.substring(0,\"securityPolicy\".length);\n");
      out.write("      var preCli = el.name.substring(0,\"cliAcl\".length);\n");
      out.write("      if (pre == \"securityPolicy\" && el.value != \"SELECT\") {\n");
      out.write("        var post = el.name.substring(\"securityPolicy\".length,el.name.length);\n");
      out.write("        var list = document.getElementsByName(\"policy\"+post);\n");
      out.write("        if (list.length == 1) {\n");
      out.write("          if (list[0].value == \"\") {\n");
      out.write("            alert('Please enter a ");
      out.print( ub.getTag( "yams.jsp.NetworkAccessID" ));
      out.write(". It is required when setting a ");
      out.print( ub.getTag( "yams.jsp.PolicyName" ));
      out.write(".');\n");
      out.write("            list[0].focus();\n");
      out.write("            return false;\n");
      out.write("          }\n");
      out.write("        }\n");
      out.write("      }\n");
      out.write("      if (preCli == \"cliAcl\" && el.value != \"SELECT\") {\n");
      out.write("        var post = el.name.substring(\"cliAcl\".length,el.name.length);\n");
      out.write("        var list = document.getElementsByName(\"policy\"+post);\n");
      out.write("        if (list.length == 1) {\n");
      out.write("          if (list[0].value == \"\") {\n");
      out.write("            alert('Please enter a ");
      out.print( ub.getTag( "yams.jsp.NetworkAccessID" ));
      out.write(". It is required when setting a CLI task.');\n");
      out.write("            list[0].focus();\n");
      out.write("            return false;\n");
      out.write("          }\n");
      out.write("        }\n");
      out.write("      }\n");
      out.write("    }\n");
      out.write("  } catch (e) {\n");
      out.write("    alert(e);\n");
      out.write("  }\n");
      out.write("  return true;\n");
      out.write("}\n");
      out.write("//-->\n");
      out.write("</script> \n");
      out.write("<form method=\"POST\" action=\"RolePolicy.jsp?deviceID=");
      out.print(deviceID);
      out.write("\" onsubmit=\"return validate(this);\">\n");
      out.write("<div class=\"content\">\n");
      out.write("  <table>\n");
      out.write("    <tr>\n");
      out.write("      <td colspan=\"2\" class=\"bgsub\">");
      out.print( ub.getTag( "yams.jsp.Role" ));
      out.write("</td>\n");
      out.write("    </tr>\n");
      out.write("    <tr>\n");
      out.write("      <td width=\"30%\">");
      out.print( ub.getTag( "yams.jsp.Name" ));
      out.write("</td>\n");
      out.write("      <td width=\"70%\">");
      out.print(roleName);
      out.write("</td>\n");
      out.write("    </tr>\n");
      out.write("    <tr>\n");
      out.write("      <td>");
      out.print( ub.getTag( "yams.jsp.ClientCount" ));
      out.write("</td>\n");
      out.write("      <td>");
      out.print(clientCount);
      out.write(" </td>\n");
      out.write("    </tr>\n");
      out.write("    <tr>\n");
      out.write("      <td colspan=\"2\" align=\"center\">&nbsp; </td>\n");
      out.write("    </tr>\n");
      out.write("  </table>\n");
      out.write("  <table>\n");
      out.write("    <tr>\n");
      out.write("      <td colspan=\"5\" class=\"bgsub\">\n");
      out.write("        ");
      out.print( ub.getTag( "yams.jsp.GroupType" ));
      out.write("\n");
      out.write("        <select name=\"groupType\" onchange=\"document.forms[0].submit()\">\n");
      out.write("           <option value=\"device\" ");
      out.print((groupType.equals("device") ? " selected":""));
      out.write(">\n");
      out.write("               ");
      out.print( ub.getTag( "yams.jsp.DeviceGroups"));
      out.write("</option>\n");
      out.write("           <option value=\"port\" ");
      out.print((groupType.equals("port") ? " selected":""));
      out.write(">\n");
      out.write("               ");
      out.print( ub.getTag( "yams.jsp.PortGroups"));
      out.write("</option>\n");
      out.write("        </select>\n");
      out.write("      </td>\n");
      out.write("    </tr>\n");
      out.write("    <tr>\n");
      out.write("      <td class=\"bgs\" width=\"23%\">");
      out.print( ub.getTag( "yams.jsp.Name" ));
      out.write("</td>\n");
      out.write("      <td class=\"bgs\" width=\"10%\">");
      out.print( ub.getTag( "yams.jsp.Count" ));
      out.write("</td>\n");
      out.write("      <td class=\"bgs\" width=\"22%\">");
      out.print( ub.getTag( "yams.jsp.NetworkAccessID" ));
      out.write("</td>\n");
      out.write("      <td class=\"bgs\" width=\"23%\">Command Line Script</td>\n");
      out.write("      <td class=\"bgs\" width=\"22%\">");
      out.print( ub.getTag( "yams.jsp.PolicyName" ));
      out.write("</td>\n");
      out.write("    </tr>\n");
      out.write("    ");
      out.print(showGroupHierarchy(campusBean, deviceGroups, groupIDs, roleName, groupType, policyList, taskList) );
      out.write("\n");
      out.write("  </table>\n");
      out.write("</div>\n");
      out.write("<div class=\"control\">\n");
      out.write("  <table>\n");
      out.write("    <tr>\n");
      out.write("      <td>&nbsp; </td>\n");
      out.write("      <td>&nbsp; </td>\n");
      out.write("      <td>\n");
      out.write("        <input type=\"hidden\" value=\"");
      out.print(roleName );
      out.write("\" name=\"roleName\" >\n");
      out.write("        <input type=\"hidden\" value=\"");
      out.print(clientCount );
      out.write("\" name=\"clientCount\" >\n");
      out.write("      </td>\n");
      out.write("      <td>\n");
      out.write("        <input class=\"button\" type=\"submit\" value=\"Apply\" name=\"action\">\n");
      out.write("      </td>\n");
      out.write("      <td>\n");
      out.write("        <input class=\"button\" type=\"reset\" value=\"Reset\" name=\"reset\">\n");
      out.write("      </td>\n");
      out.write("    </tr>\n");
      out.write("  </table>\n");
      out.write("</div>\n");
      out.write("</form>\n");
      out.write(' ');
      out.write('\n');
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
